release upgrades should jump over unsupported releases

Bug #1497024 reported by Brian Murray on 2015-09-17
12
This bug affects 2 people
Affects Status Importance Assigned to Milestone
ubuntu-release-upgrader (Ubuntu)
High
Unassigned
Trusty
High
Unassigned
Vivid
High
Unassigned
update-manager (Ubuntu)
High
Brian Murray
Trusty
High
Brian Murray
Vivid
High
Brian Murray

Bug Description

[Impact]

Currently, users of 14.04 LTS with /etc/update-manager/release-upgrades's prompt set to normal are offered to upgrade to the unsupported release 14.10. In the past when 13.04 became unsupported before 12.10 we offered upgrades from 12.10 to 13.10. Skipping an unsupported release also puts us in a better position to ensure LTS to LTS upgrades work. Subsequently, update-manager and ubuntu-release-upgrader should be modified so that users can upgrade from 14.04 to 15.04.

[Test Case]

There isn't a great test case for the Vivid update-manager change as the change will only have an effect when W is unsupported. Having said that I did add a test to update-manager which verifies the logic of the change. Additionally, it would be good to ensure an offer to upgrade to Wily is given when running 'do-release-upgrade -d'.

[Regression Potential]

If the patch is incorrect upgrades to the development release of Ubuntu won't be offered. There is a test for that and running 'do-release-upgrade -d' on Vivid will prove that it works.

The changes to update-manager will be generic enough to work going forward, but the ubuntu-release-upgrader changes may require regular updates as a release becomes End of Life.

Changed in ubuntu-release-upgrader (Ubuntu):
importance: Undecided → High
Changed in update-manager (Ubuntu):
importance: Undecided → High
Changed in ubuntu-release-upgrader (Ubuntu Trusty):
status: New → Invalid
Changed in update-manager (Ubuntu Vivid):
status: New → Won't Fix
Changed in update-manager (Ubuntu):
status: New → In Progress
assignee: nobody → Brian Murray (brian-murray)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:15.10.1

---------------
update-manager (1:15.10.1) wily; urgency=medium

  * UpdateManager/Core/MetaRelease.py: When not running in development mode,
    if the next release is unsupported do not offer to upgrade to that, but
    the release after it. When running in development mode continue to offer
    upgrading to unsupported release. (LP: #1497024)

 -- Brian Murray <email address hidden> Thu, 17 Sep 2015 15:10:19 -0700

Changed in update-manager (Ubuntu):
status: In Progress → Fix Released
Brian Murray (brian-murray) wrote :

This will need SRU'ing to 15.04 because people may not try upgrading until after 15.10 becomes End of Life, and in that case they should be offered 16.04

Changed in update-manager (Ubuntu Vivid):
status: Won't Fix → Triaged
assignee: nobody → Brian Murray (brian-murray)
Changed in update-manager (Ubuntu Vivid):
status: Triaged → In Progress
importance: Undecided → High
description: updated
Changed in update-manager (Ubuntu Trusty):
status: New → In Progress
assignee: nobody → Brian Murray (brian-murray)

Hello Brian, or anyone else affected,

Accepted update-manager into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:0.196.14 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-manager (Ubuntu Trusty):
status: In Progress → Fix Committed
tags: added: verification-needed
Changed in update-manager (Ubuntu Vivid):
status: In Progress → Fix Committed
Chris J Arges (arges) wrote :

Hello Brian, or anyone else affected,

Accepted update-manager into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:15.04.7.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in update-manager (Ubuntu Trusty):
importance: Undecided → High
Brian Murray (brian-murray) wrote :

bdmurray@blacklightning:~/Documents/gtd$ apt-cache policy update-manager
update-manager:
  Installed: 1:15.04.7.1
  Candidate: 1:15.04.7.1
  Version table:
 *** 1:15.04.7.1 0
        100 /var/lib/dpkg/status
     1:15.04.7 0
        500 http://ubuntu.osuosl.org/ubuntu/ vivid/main amd64 Packages

bdmurray@blacklightning:~/Documents/gtd$ do-release-upgrade -c -d
Checking for a new Ubuntu release
New release '15.10' available.
Run 'do-release-upgrade' to upgrade to it.
bdmurray@blacklightning:~/Documents/gtd$ do-release-upgrade -c
Checking for a new Ubuntu release
No new release found

tags: added: verificationd-done-vivid
tags: added: verification-done-vivid
removed: verificationd-done-vivid
Chris J Arges (arges) wrote :

Hello Brian, or anyone else affected,

Accepted ubuntu-release-upgrader into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/ubuntu-release-upgrader/1:15.04.14.2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in ubuntu-release-upgrader (Ubuntu Vivid):
status: New → Fix Committed
Changed in ubuntu-release-upgrader (Ubuntu Trusty):
importance: Undecided → High
Changed in ubuntu-release-upgrader (Ubuntu Vivid):
importance: Undecided → High
Mathew Hodson (mathew-hodson) wrote :

When I run update-manager on Trusty, I correctly get, "The software on this computer is up to date. However, Ubuntu 15.04 is now available (you have 14.04)."

do-release-upgrade doesn't work though, and 'do-release-upgrade -d' offers an upgrade to Utopic.

$ sudo do-release-upgrade
Checking for a new Ubuntu release
Get:1 Upgrade tool signature [198 B]
Get:2 Upgrade tool [1,221 kB]
Fetched 1,221 kB in 0s (0 B/s)
authenticate 'vivid.tar.gz' against 'vivid.tar.gz.gpg'
extracting 'vivid.tar.gz'

Reading cache

Checking package manager

Cannot upgrade

An upgrade from 'trusty' to 'vivid' is not supported with this tool.

$ do-release-upgrade -c -d
Checking for a new Ubuntu release
New release '14.10' available.
Run 'do-release-upgrade' to upgrade to it.

description: updated
Brian Murray (brian-murray) wrote :

So the update-manager part of the verification is done as you were offered to upgrade to Vivid. To test the ubuntu-release-upgrader part you'll need to use 'do-release-upgrade -p' which will use the release upgrade tarball from -proposed.

Mathew Hodson (mathew-hodson) wrote :

$ do-release-upgrade -p
Checking for a new Ubuntu release
No new release found

No new release was found, but the expected behaviour is that it should offer an upgrade to 15.04 like update-manager, right?

Does ubuntu-release-upgrader need a new upload for Trusty? the Trusty task is currently marked Invalid.

Brian Murray (brian-murray) wrote :

Ah, right. do-release-upgrade loads the meta-release file information from http://changelogs.ubuntu.com/meta-release with some modifications for the -d (-development) and -p (-proposed) switches. However, meta-release-proposed doesn't contain information about Vivid nor does it point to the vivid-proposed version of the release upgrader. I'll fix that now.

Brian Murray (brian-murray) wrote :

Okay, vivid is now in meta-release-proposed.

Brian Murray (brian-murray) wrote :

I've tested do-release-upgrade -p and the upgrade to Vivid from Trusty did start so the ubuntu-release-upgrader part of this bug is verification-done.

tags: added: verification-done-trusty
removed: verification-needed
Mathew Hodson (mathew-hodson) wrote :

'do-release-upgrade -d' is currently offering an upgrade to 14.10.

Should it offer to upgrade to WIly? Wily is the current development release.

Brian Murray (brian-murray) wrote :

Mathew - that's an interesting idea I had not considered. It makes sense if we are skipping versions for stable releases to also skip versions for development releases. Having said that though, the code in update-manager parses the meta-release files to determine which release to upgrade. As an example here is the meta-release-development entry for utopic.

Dist: utopic
Name: Utopic Unicorn
Version: 14.10
Date: Thu, 23 Oct 2014 14:10:00 UTC
Supported: 0
Description: This is the 14.10 release
Release-File: http://archive.ubuntu.com/ubuntu/dists/utopic/Release
ReleaseNotes: http://changelogs.ubuntu.com/EOLReleaseAnnouncement
UpgradeTool: http://archive.ubuntu.com/ubuntu/dists/utopic/main/dist-upgrader-all/current/utopic.tar.gz
UpgradeToolSignature: http://archive.ubuntu.com/ubuntu/dists/utopic/main/dist-upgrader-all/current/utopic.tar.gz.gpg

We currently just check the date and supported status to determine to which release to upgrade, as the meta release files don't really contain information about whether or not a release is obsolete. Thinking about it more though, if we are running with the -d switch we could check to see if the release date is greater than today. There should probably be a fudge factor of a day though as otherwise people may not be able to upgrade on release day.

Brian Murray (brian-murray) wrote :

Could you open a new bug report about this idea? Thanks!

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:0.196.14

---------------
update-manager (1:0.196.14) trusty-proposed; urgency=medium

  * UpdateManager/Core/MetaRelease.py: When not running in development mode,
    if the next release is unsupported do not offer to upgrade to that, but
    the release after it. When running in development mode continue to offer
    upgrading to unsupported release. (LP: #1497024)

 -- Brian Murray <email address hidden> Fri, 18 Sep 2015 13:36:59 -0700

Changed in update-manager (Ubuntu Trusty):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for update-manager has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:15.04.7.1

---------------
update-manager (1:15.04.7.1) vivid-proposed; urgency=medium

  * UpdateManager/Core/MetaRelease.py: When not running in development mode,
    if the next release is unsupported do not offer to upgrade to that, but
    the release after it. When running in development mode continue to offer
    upgrading to unsupported release. (LP: #1497024)

 -- Brian Murray <email address hidden> Thu, 17 Sep 2015 14:51:31 -0700

Changed in update-manager (Ubuntu Vivid):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-release-upgrader - 1:15.04.14.2

---------------
ubuntu-release-upgrader (1:15.04.14.2) vivid-proposed; urgency=medium

  * Support upgrading from Trusty to Vivid directly since Utopic is End of
    Life. (LP: #1497024)
  * DistUpgrade/build-tarball.sh: Copy the contents of demoted.cfg so it is
    not a broken symlink. (LP: #1498193)

 -- Brian Murray <email address hidden> Mon, 21 Sep 2015 13:05:19 -0700

Changed in ubuntu-release-upgrader (Ubuntu Vivid):
status: Fix Committed → Fix Released
Changed in ubuntu-release-upgrader (Ubuntu):
status: New → Confirmed
Brian Murray (brian-murray) wrote :

This does not need fixing in Wily for ubuntu-release-upgrader, because the release after Wily is an LTS release and will not become unsupported before Wily.

Changed in ubuntu-release-upgrader (Ubuntu):
status: Confirmed → Invalid
mirak (mirak-mirak) wrote :

so what must we do when we want to do-release-upgrade on trusty to go to 15.10 ???

Brian Murray (brian-murray) wrote :

@mirak - you should wait for 15.04 to be unsupported then a "normal" upgrade from 14.04 will be to 15.10.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers